package com.steerinfo.baseinfo.meterbaserailwayhistaredetail.controller;

import com.steerinfo.baseinfo.meterbasehistaredetail.model.MeterBaseHisTareDetail;
import com.steerinfo.baseinfo.meterbaserailwayhistaredetail.model.MeterBaseRailwayHisTareDetail;
import com.steerinfo.baseinfo.meterbaserailwayhistaredetail.service.IMeterBaseRailwayHisTareDetailService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseRailwayHisTareDetail RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-04-02 10:57
 * 类描述
 * 修订历史：
 * 日期：2022-04-02
 * 作者：generator
 * 参考：
 * 描述：MeterBaseRailwayHisTareDetail RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaserailwayhistaredetails")
public class MeterBaseRailwayHisTareDetailController extends BaseRESTfulController {

    @Autowired
    IMeterBaseRailwayHisTareDetailService meterBaseRailwayHisTareDetailService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwayhistaredetail:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRailwayHisTareDetail> list = meterBaseRailwayHisTareDetailService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwayhistaredetail:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRailwayHisTareDetail> list = meterBaseRailwayHisTareDetailService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseRailwayHisTareDetail对象创建")
    @ApiImplicitParam(name = "meterBaseRailwayHisTareDetail", value = "详细实体meterBaseRailwayHisTareDetail", required = true, dataType = "MeterBaseRailwayHisTareDetail")
    //@RequiresPermissions("meterbaserailwayhistaredetail:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseRailwayHisTareDetail model){
        MeterBaseRailwayHisTareDetail meterBaseRailwayHisTareDetail = meterBaseRailwayHisTareDetailService.add(model);
        return success(meterBaseRailwayHisTareDetail);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserailwayhistaredetail:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseRailwayHisTareDetail meterBaseRailwayHisTareDetail = meterBaseRailwayHisTareDetailService.getById(id);
        return success(meterBaseRailwayHisTareDetail);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseRailwayHisTareDetail信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseRailwayHisTareDetail", value = "详细实体meterBaseRailwayHisTareDetail", required = true, dataType = "MeterBaseRailwayHisTareDetail")
    })
    //@RequiresPermissions("meterbaserailwayhistaredetail:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseRailwayHisTareDetail model){
        model.setId(id);
        MeterBaseRailwayHisTareDetail meterBaseRailwayHisTareDetail = meterBaseRailwayHisTareDetailService.modify(model);
        return success(meterBaseRailwayHisTareDetail);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserailwayhistaredetail:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseRailwayHisTareDetailService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="获取最新详细列表", notes="分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwayhistaredetail:view")
    @GetMapping(value = "/listByDesc")
    public RESTfulResult listByDesc(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRailwayHisTareDetail> list = meterBaseRailwayHisTareDetailService.listByDesc(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value = "启用-网页", notes = "根据传过来的MeterBaseRailwayHisTareDetail集合信息来更新详细信息")
    @ApiImplicitParam(name = "MeterBaseRailwayHisTareDetail", value = "详细实体MeterBaseHisTareDetail", required = true, dataType = "MeterBaseRailwayHisTareDetail")
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult Recovery(@RequestBody MeterBaseRailwayHisTareDetail model) {
        try {
            String msg = meterBaseRailwayHisTareDetailService.Recovery(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "逻辑删除-网页", notes = "根据传过来的MeterBaseRailwayHisTareDetail集合信息来更新详细信息")
    @ApiImplicitParam(name = "MeterBaseRailwayHisTareDetail", value = "详细实体MeterBaseRailwayHisTareDetail", required = true, dataType = "MeterBaseRailwayHisTareDetail")
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody MeterBaseRailwayHisTareDetail model) {
        try {
            String msg = meterBaseRailwayHisTareDetailService.abolish(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

}
